<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				https://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2009 - 2018 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

defined( '_JEXEC' ) or die;

// Plugin
class plgCCK_Field_TypoImage extends JCckPluginTypo
{
	protected static $type			=	'image';
	protected static $thumb_count	=	6;
	protected static $path;
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Prepare
		
	// onCCK_Field_TypoPrepareContent
	public function onCCK_Field_TypoPrepareContent( &$field, $target = 'value', &$config = array() )
	{
		if ( self::$type != $field->typo ) {
			return;
		}
		self::$path	=	JUri::root().'plugins/cck_field_typo/'.self::$type.'/';
		
		// Prepare
		if ( $field->value && $field->value != '' ) {
			$typo	=	parent::g_getTypo( $field->typo_options );
			$field->typo	=	self::_typo( $typo, $field, '', $config );
		} else {
			$field->typo	=	'';
		}
	}
		
	// _typo
	protected static function _typo( $typo, &$field, $value, &$config = array() )
	{
		// Prepare
		$options		=	array(
								'base'=>JUri::root( true ).'/',
								'attributes'=>$typo->get( 'attributes', '' ),
								'class'=>$typo->get( 'class', '' ),
								'root'=>( $typo->get( 'path_type', 0 ) ? JUri::root() : '' )
							);
		$thumb_array	=	array(
								'state'=>$typo->get( 'state', 1 ),
								'thumb'=>$typo->get( 'thumb', 'thumb1' ),
								'thumb_2x'=>$typo->get( 'thumb_2x', '' ),
								'thumb_3x'=>$typo->get( 'thumb_3x', '' ),
								'thumb_custom'=>$typo->get( 'thumb_custom', 0 ),
								'thumb_width'=>$typo->get( 'thumb_width', '' ),
								'thumb_height'=>$typo->get( 'thumb_height', '' ),
								'image'=>$typo->get( 'image', 'value' ),
								'image_custom'=>$typo->get( 'image_custom', 0 ),
								'image_width'=>$typo->get( 'image_width', '' ),
								'image_height'=>$typo->get( 'image_height', '' ),
								'image_title'=>$typo->get( 'image_title', 1 ),
								'image_extension'=>$typo->get( 'image_extension', 0 ),
								'image_tag'=>$typo->get( 'image_tag', 0 ),
								'image_alt'=>$typo->get( 'image_alt', 1 ),
								'image_alt_fieldname'=>$typo->get( 'image_alt_fieldname', '' )
							);

		if ( is_array( $field->value ) ) {
			$typo	=	self::_addImages( $field, $thumb_array, $options, $config );
		} else {
			$typo	=	self::_addImage( $field, $thumb_array, $options, $config );
		}
		if ( $thumb_array['image_alt'] && $thumb_array['image_alt_fieldname'] != '' ) {
			parent::g_addProcess( 'beforeRenderContent', self::$type, $config, array( 'name'=>$field->name, 'alt_fieldname'=>$thumb_array['image_alt_fieldname']  ) );
		}
		
		return $typo;
	}

	// -------- -------- -------- -------- -------- -------- -------- -------- // Special Events
	
	// onCCK_Field_TypoBeforeRenderContent
	public static function onCCK_Field_TypoBeforeRenderContent( $process, &$fields, &$storages, &$config = array() )
	{
		if ( @$fields[$process['alt_fieldname']] ) {
			if ( is_array( $fields[$process['name']]->value ) ) {
				foreach ( $fields[$process['name']]->value as $k=>$field ) {
					if ( isset( $field->image_alt ) && $field->image_alt ) {
						$search 						= 	'alt="'.$field->image_alt.'"';
						$replace						=	'alt="'.htmlspecialchars( $fields[$process['alt_fieldname']]->value ).'"';
						$fields[$process['name']]->typo	=	str_replace( $search, $replace, $fields[$process['name']]->typo );	
					}
					if ( isset( $field->image_title ) && $field->image_title ) {
						$search 						= 	'title="'.$field->image_title.'"';
						$replace						=	'title="'.htmlspecialchars( $fields[$process['alt_fieldname']]->value ).'"';
						$fields[$process['name']]->typo	=	str_replace( $search, $replace, $fields[$process['name']]->typo );
					}
				}
			} else {
				if ( isset( $fields[$process['name']]->image_alt ) && $fields[$process['name']]->image_alt ) {
					$search 						= 	'alt="'.$fields[$process['name']]->image_alt.'"';
					$replace						=	'alt="'.htmlspecialchars( $fields[$process['alt_fieldname']]->value ).'"';
					$fields[$process['name']]->typo	=	str_replace( $search, $replace, $fields[$process['name']]->typo );	
				}
				if ( isset( $fields[$process['name']]->image_title ) && $fields[$process['name']]->image_title ) {
					$search 						= 	'title="'.$fields[$process['name']]->image_title.'"';
					$replace						=	'title="'.htmlspecialchars( $fields[$process['alt_fieldname']]->value ).'"';
					$fields[$process['name']]->typo	=	str_replace( $search, $replace, $fields[$process['name']]->typo );
				}
			}
		}
	}

	// _addImage
	protected static function _addImage( &$field, $params, $options, $config )
	{
		$alt				=	'';
		$value				=	$field->value;

		$ext				=	substr( strrchr( $field->value, "." ), 1 );
		$filename			=	substr( strrchr( $field->value, "/" ), 1 );
		$filename			=	str_replace('.'.$ext,'',$filename);
		
		if ( $params['image_alt'] ) {
			$alt			=	' alt="'.$field->image_alt.'"';
		}

		$image_title		=	( isset( $field->image_title ) ) ? $field->image_title : '';
		$field->image_title	=	( $image_title != '' ) ? $image_title : $filename;
		$image_alt			=	( isset( $field->image_alt ) ) ? $field->image_alt : '';
		$field->image_alt	=	( $image_alt != '' ) ? $image_alt : $image_title;
		$field->image_title	=	( $params['image_title'] && $field->image_title ) ? $field->image_title : '';
		$title				=	( $field->image_title ) ? ' title="'.$field->image_title.'" ' : '';

		$attr				=	( $options['attributes'] != '' ) ? ' '.$options['attributes'] : '';
		$class				=	( $options['class'] != '' ) ? ' class="'.$options['class'].'"' : '';
		$height				=	'';
		$srcset				=	'';
		$width				=	'';

		if ( (int)$params['image_tag'] == 1 ) {
			$img_src	=	'srcset';
			$img_tag	=	'source';
		} else {
			$img_src	=	'src';
			$img_tag	=	'img';
		}

		if ( $params['thumb_custom'] == 1 ) {
			$width	=	' width="'.$params['thumb_width'].'"';
			$height	=	' height="'.$params['thumb_height'].'"';
		}
		if ( $params['thumb_2x'] ) {
			$srcset	=	( $options['root'] ? '' : $options['base'] ).self::_availableThumb( $field, $params['thumb_2x'], $options, $params ).' 2x';
			if ( $params['thumb_3x'] ) {
				$srcset	.=	', '.( $options['root'] ? '' : $options['base'] ).self::_availableThumb( $field, $params['thumb_3x'], $options, $params ).' 3x';
			}
			$srcset	=	' srcset="'.$srcset.'"';
		}
		$attr		=	$title.$alt.' '.$img_src.'="'.self::_availableThumb( $field, $params['thumb'], $options, $params ).'"'.$srcset.$class.$attr.$width.$height;
		
		if ( !$params['state'] ) {
			$attr			=	trim( $attr );
			$field->html	=	$attr;
			$typo			=	$attr;

			return $typo;
		}

		if ( $attr != '' && strpos( $attr, '%' ) !== false ) {
			$matches	=	'';
			$search		=	'#\%([a-zA-Z0-9-]*)\%#U';

			preg_match_all( $search, $attr, $matches );

			if ( count( $matches[1] ) ) {
				foreach ( $matches[1] as $target ) {
					$replace	=	'';

					if ( isset( $config['context'][$target] ) && $config['context'][$target] != '' ) {
						$replace	=	$target.'="'.$config['context'][$target].'"';
					}
					
					$attr	=	str_replace( '%'.$target.'%', $replace, $attr );
				}
			}
		}

		$img	=	'<'.$img_tag.$attr.' />';

		if ( isset( $field->link ) && $field->link ) {
			$typo	=	parent::g_hasLink( $field, new stdClass, $img );
		} elseif ( $params['image'] == 'none' ) {
			$typo	=	$img;
		} else {
			if ( (int)JCck::getConfig_Param( 'site_modal_box', '0' ) ) {
				$typo	=	'<a href="'.self::_availableValue( $field, $params['image'], $options ).'" title="'.$field->image_alt.'" data-cck-modal=\'{"mode":"image","body":false,"header":false}\'>'.$img.'</a>';
			} else {
				$typo	=	'<a id="colorBox'.$field->id.'" href="'.self::_availableValue( $field, $params['image'], $options ).'" rel="colorBox'.$field->id.'" title="'.$field->image_alt.'">'.$img.'</a>';
			}
		}
		if ( $params['image'] != 'none' ) {
			if ( !(int)JCck::getConfig_Param( 'site_modal_box', '0' ) ) {
				self::_addScripts( array( 'id'=>$field->id ), $params );
			}
		}
		$field->html	=	$img;
		
		return $typo;
	}

	// _addImages
	protected static function _addImages( &$field, $params, $options, $config )
	{
		// Prepare
		$value	=	$field->value;
		$typo	=	'';
		
		foreach ( $field->value as $value_img ) {
			$typo	.=	self::_addImage( $value_img, $params, $options, $config );
		}
		
		return $typo;
	}

	// _addScripts
	protected static function _addScripts( $params, $options )
	{
		$doc		=	JFactory::getDocument();
		$height		=	'';
		$width		=	'';
		
		if ( $options['image_custom'] > 0 ) {
			$dim	=	array( 'w'=>array( 1=>'width', 2=>'innerWidth', 3=>'maxWidth' ), 'h'=>array( 1=>'height', 2=>'innerHeight', 3=>'maxHeight' ) );
			$width	=	$dim['w'][$options['image_custom']].':'.$options['image_width'];
			$height	=	', '.$dim['h'][$options['image_custom']].':'.$options['image_height'];
		}
		$options	=	'{'.$width.$height.'}';
		
		JCck::loadjQuery();
		JCck::loadModalBox();
		if ( $params['id'] ) {
			$js	=	'jQuery(document).ready(function($){ $("a[rel=\'colorBox'.$params['id'].'\']").colorbox('.$options.'); });';
			$doc->addScriptDeclaration( $js );
		}
	}

	// _availableThumb
	protected static function _availableThumb( $field, $thumb, $options, $params )
	{
		if ( isset( $field->$thumb ) && $field->$thumb ) {
			if ( (int)$params['image_extension'] == 1 ) {
				return str_replace( '.'.$field->extension, '.webp', $options['root'].$field->$thumb );
			} else {
				return $options['root'].$field->$thumb;
			}
		} else {
			for ( $i = 1; $i < self::$thumb_count; $i++ ) {
				if ( isset( $field->{'thumb'.$i} ) && $field->{'thumb'.$i} ) {
					if ( (int)$params['image_extension'] == 1 ) {
						return str_replace( '.'.$field->extension, '.webp', $options['root'].$field->{'thumb'.$i} );
					} else {
						return $options['root'].$field->{'thumb'.$i};
					}
				}
			}
			if ( isset( $field->value ) && $field->value ) {
				return $options['root'].$field->value;
			}		
		}
	}

	// _availableValue
	protected static function _availableValue( $field, $thumb, $options )
	{
		if ( isset( $field->$thumb ) && $field->$thumb ) {
			return $options['root'].$field->$thumb;
		} else {
			if ( isset( $field->value ) && $field->value ) {
				return $options['root'].$field->value;
			} else {
				for ( $i = 1 ; $i < self::$thumb_count; $i++ ) {
					if ( isset( $field->{'thumb'.$i} ) && $field->{'thumb'.$i} ) {
						return $options['root'].$field->{'thumb'.$i};
					}
				}
			}
		}
	}
}
?>