UPDATE `#__cck_core_type_field` SET `variation` = "hidden" WHERE `variation` = "none";
UPDATE `#__cck_core_search_field` SET `variation` = "hidden" WHERE `variation` = "none";

CREATE TABLE IF NOT EXISTS `#__cck_core_sites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL,
  `name` varchar(50) NOT NULL,
  `guest` int(11) NOT NULL,
  `guest_only_group` int(11) NOT NULL,
  `guest_only_viewlevel` int(11) NOT NULL,
  `groups` varchar(255) NOT NULL,
  `viewlevels` varchar(255) NOT NULL,
  `configuration` varchar(1024) NOT NULL,
  `description` varchar(5120) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;

ALTER TABLE `#__cck_core_type_field` ADD `link_options` VARCHAR( 1024 ) NOT NULL COMMENT 'content,intro' AFTER `link`;
ALTER TABLE `#__cck_core_type_field` ADD `conditional` VARCHAR( 255 ) NOT NULL COMMENT 'admin,site' AFTER `access`;
ALTER TABLE `#__cck_core_type_field` ADD `conditional_options` VARCHAR( 1024 ) NOT NULL COMMENT 'admin,site' AFTER `conditional`;
ALTER TABLE `#__cck_core_type_field` CHANGE `typo_options` `typo_options` VARCHAR( 2048 ) NOT NULL COMMENT 'content,intro';

ALTER TABLE `#__cck_core_search_field` ADD `link_options` VARCHAR( 1024 ) NOT NULL COMMENT 'item' AFTER `link`;
ALTER TABLE `#__cck_core_search_field` ADD `conditional` VARCHAR( 255 ) NOT NULL COMMENT 'search' AFTER `access`;
ALTER TABLE `#__cck_core_search_field` ADD `conditional_options` VARCHAR( 1024 ) NOT NULL COMMENT 'search' AFTER `conditional`;
ALTER TABLE `#__cck_core_search_field` CHANGE `typo_options` `typo_options` VARCHAR( 2048 ) NOT NULL COMMENT 'item';

INSERT INTO `#__cck_core_fields` (`id`, `title`, `name`, `folder`, `type`, `description`, `published`, `label`, `selectlabel`, `display`, `required`, `validation`, `defaultvalue`, `options`, `options2`, `minlength`, `maxlength`, `size`, `cols`, `rows`, `ordering`, `sorting`, `divider`, `bool`, `location`, `extended`, `style`, `script`, `bool2`, `bool3`, `bool4`, `bool5`, `bool6`, `bool7`, `bool8`, `css`, `attributes`, `storage`, `storage_location`, `storage_table`, `storage_field`, `storage_field2`, `storage_params`, `storages`, `checked_out`, `checked_out_time`) VALUES
(201, 'Core Title (Site)', 'core_title_site', 3, 'text', '', 0, 'Title', ' ', 3, 'required', '', '', '', '', 0, 255, 28, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', 'tabindex="1"', 'dev', '', '', 'title', '', '', '', 0, '0000-00-00 00:00:00'),
(202, 'Core Name (Site)', 'core_name_site', 3, 'text', '', 0, 'Url', ' ', 3, 'required', '', '', '', '', 0, 50, 28, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', 'tabindex="2"', 'dev', '', '', 'name', '', '', '', 0, '0000-00-00 00:00:00'),
(203, 'Core Guest', 'core_guest', 3, 'select_dynamic', '', 0, 'Guest', 'Select a User', 3, '', '', '', '', '{"query":"SELECT ","table":"#__users","name":"name","where":"","value":"id","orderby":"name","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'guest', '', '', '', 0, '0000-00-00 00:00:00'),
(204, 'Core Viewlevels', 'core_viewlevels', 3, 'select_dynamic', '', 0, 'Viewing Access Levels', ' ', 3, '', '', '', '', '{"query":"","table":"#__viewlevels","name":"title","where":"","value":"id","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 1, 0, 0, 0, 0, 0, '', '', 'dev', 'joomla_article', '', 'viewlevels', '', '', '', 0, '0000-00-00 00:00:00'),
(205, 'Core Groups', 'core_groups', 3, 'select_dynamic', '', 0, 'User Groups', ' ', 3, '', '', '', '', '{"query":"","table":"#__usergroups","name":"title","where":"","value":"id","orderby":"lft","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 1, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'groups', '', '', '', 0, '0000-00-00 00:00:00'),
(206, 'Core Site Name', 'core_site_name', 3, 'text', '', 0, 'Site Name', ' ', 3, '', '', '', '', '', 0, 255, 32, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][sitename]', '', '', '', 0, '0000-00-00 00:00:00'),
(207, 'Core Site Offline', 'core_site_offline', 3, 'radio', '', 0, 'Offline', ' ', 3, '', '', '0', 'No=0||Yes=1', '', 0, 50, 32, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'offline', '', '', '', 0, '0000-00-00 00:00:00'),
(208, 'Core Site Metadesc', 'core_site_metadesc', 3, 'textarea', '', 0, 'Meta Description', ' ', 3, '', '', '', '', '', 0, 255, 32, 25, 3, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][metadesc]', '', '', '', 0, '0000-00-00 00:00:00'),
(209, 'Core Site Metakeys', 'core_site_metakeys', 3, 'textarea', '', 0, 'Meta Keywords', ' ', 3, '', '', '', '', '', 0, 255, 32, 25, 3, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][metakeys]', '', '', '', 0, '0000-00-00 00:00:00'),
(210, 'Core Site Pagetitles', 'core_site_pagetitles', 3, 'select_simple', '', 0, 'Include Site Name', ' ', 3, '', '', '', 'No=0||After Page Titles=2||Before Page Titles=1', '', 0, 50, 32, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][sitename_pagetitles]', '', '', '', 0, '0000-00-00 00:00:00'),
(211, 'Core Site Live Value', 'core_site_live_value', 3, 'text', '', 0, 'Live Value', ' ', 3, '', '', '', '', '', 0, 255, 32, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'live_value', '', '', '', 0, '0000-00-00 00:00:00'),
(212, 'Core Site Live Values', 'core_site_live_values', 3, 'field_x', '', 0, 'Live Values', ' ', 3, '', '', '', '', '', 1, 10, 32, 0, 1, 0, 0, '', 0, '', 'core_site_live_value', '', '', 1, 1, 1, 0, 0, 0, 0, '', '', 'dev', '', '', 'live_values', '', '', '', 0, '0000-00-00 00:00:00'),
(213, 'Core Guest Only (Viewlevel)', 'core_guest_only_viewlevel', 3, 'select_dynamic', '', 0, 'Guest Only Viewing Access Level', 'Select a Viewing Access Level', 3, '', '', '', '', '{"query":"","table":"#__viewlevels","name":"title","where":"","value":"id","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'guest_only_viewlevel', '', '', '', 0, '0000-00-00 00:00:00'),
(214, 'Core Site Template_style', 'core_site_template_style', 3, 'select_dynamic', '', 0, 'Template Style', 'Use Default', 3, '', '', '', '', '{"query":"SELECT a.title AS text, a.id AS value FROM #__template_styles AS a LEFT OUTER JOIN #__cck_core_templates AS b ON b.name = a.template WHERE a.client_id = 0 AND b.name IS NULL ORDER by a.title","table":"#__content","name":"title","where":"","value":"","orderby":"","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 1, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][template_style]', '', '', '', 0, '0000-00-00 00:00:00'),
(215, 'Core Site Language', 'core_site_language', 3, 'select_dynamic', '', 0, 'Language', 'Use Default', 3, '', '', '', '', '{"query":"","table":"#__languages","name":"title","where":"","value":"sef","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][language]', '', '', '', 0, '0000-00-00 00:00:00'),
(296, 'Core Not Empty (File)', 'core_not_empty_file', 3, 'checkbox', '', 0, '', ' ', 3, '', '', '', 'Only with File=1', '', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'none', '', '', 'core_not_empty_file', '', '', '', 0, '0000-00-00 00:00:00'),
(297, 'Core Not Empty (Image)', 'core_not_empty_image', 3, 'checkbox', '', 0, '', ' ', 3, '', '', '', 'Only with Image=1', '', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'none', '', '', 'core_not_empty_image', '', '', '', 0, '0000-00-00 00:00:00'),
(218, 'Core Menuitem', 'core_menuitem', 3, 'select_dynamic', '', 0, 'Menu Item', 'Select', 3, '', '', '', '', '{"query":"","table":"#__menu","name":"title","where":"published=1 AND id !=1","value":"id","orderby":"lft","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'itemid', '', '', '', 0, '0000-00-00 00:00:00'),
(217, 'Core List', 'core_list', 3, 'select_dynamic', '', 0, 'Search Type', 'Select', 3, 'required', '', '', '', '{"query":"","table":"#__cck_core_searchs","name":"title","where":"published=1","value":"name","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'list', '', '', '', 0, '0000-00-00 00:00:00'),
(219, 'Core Site Homepage', 'core_site_homepage', 3, 'jform_menuitem', '', 0, 'Homepage', ' ', 3, '', '', '', '', '', 0, 50, 32, 0, 0, 0, 0, '', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'json[configuration][homepage]', '', '', '', 0, '0000-00-00 00:00:00'),
(220, 'Core Guest Only (Group)', 'core_guest_only_group', 3, 'select_dynamic', '', 0, 'Guest Only Group', 'Select a Group', 3, '', '', '', '', '{"query":"","table":"#__usergroups","name":"title","where":"","value":"id","orderby":"lft","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'guest_only_group', '', '', '', 0, '0000-00-00 00:00:00'),
(221, 'Core App Elements', 'core_app_elements', 3, 'checkbox', '', 0, 'Elements', ' ', 3, '', '', 'types,fields,searchs,templates,subfolders', 'Content Types=types||Fields=fields||Search Types=searchs||Templates=templates||Subfolders=subfolders', '', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'app_elements', '', '', '', 0, '0000-00-00 00:00:00'),
(222, 'Core App Dependencies', 'core_app_dependencies', 3, 'checkbox', '', 0, 'Dependencies', ' ', 3, '', '', 'categories,menuitems,plugins_variations', 'Categories=categories||Menu Items=menuitems||Plugins and Variations=plugins_variations', '', 0, 50, 32, 0, 0, 0, 0, ',', 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, '', '', 'dev', '', '', 'app_dependencies', '', '', '', 0, '0000-00-00 00:00:00');

UPDATE `#__cck_core_fields` SET `type` = 'select_dynamic', `options2` = '{"query":"","table":"#__cck_core_types","name":"title","where":"published=1","value":"name","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}' WHERE `id` = 1;
UPDATE `#__cck_core_fields` SET `type` = 'select_dynamic', `options2` = '{"query":"","table":"#__extensions","name":"element","where":"folder=\\"cck_storage_location\\" AND enabled=1","value":"element","orderby":"element","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}' WHERE `id` = 2;
UPDATE `#__cck_core_fields` SET `title` = 'Core Type (Template)', `name` = 'core_type_template', `label` = 'Type', `options` = 'Content Form=0||List=2' WHERE `id` = 24;
UPDATE `#__cck_core_fields` SET `script` = '$j("#title").live(''change'', function() { if ( !$j("#name").val() ) { var p = ""; if ($j("span.insidebox").length > 0) { var p = $j("span.insidebox").html()+"_"; } $j("#name").val( p+$j("#title").val().toLowerCase().replace(/^\\s+|\\s+$/g,"").replace(/\\s/g, "_").replace(/[^a-z0-9_]/gi, "") ) } });' WHERE `id` = 27;
UPDATE `#__cck_core_fields` SET `script` = '$j("#title").live(''change'', function() { if ( !$j("#name").val() ) { var p = ""; if ($j("span.insidebox").length > 0) { var p = $j("span.insidebox").html()+"_"; } $j("#name").val( p+$j("#title").val().toLowerCase().replace(/^\\s+|\\s+$/g,"").replace(/\\s/g, "_").replace(/[^a-z0-9_]/gi, "") ) } });' WHERE `id` = 38;
UPDATE `#__cck_core_fields` SET `options2` = '{"preparecontent":"","prepareform":"if ( $value == ''0'' ) {\\r\\n $c0 = ''checked=\\"checked\\"''; $c1 = ''''; $class = ''unpublish'';\\r\\n} else {\\r\\n $c0 = ''''; $c1 = ''checked=\\"checked\\"''; $class = ''publish'';\\r\\n}\\r\\n$form = ''<div>''\\r\\n      . ''<input type=\\"radio\\" id=\\"state0\\" name=\\"''.$name.''\\" value=\\"0\\" ''.$c0\\r\\n      . '' style=\\"display:none;\\" \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"state1\\" name=\\"''.$name.''\\" value=\\"1\\" ''.$c1\\r\\n      . '' style=\\"display:none;\\" \\/>''\\r\\n      . ''<a href=\\"javascript: void(0);\\" id=\\"state\\" class=\\"jgrid\\">''\\r\\n      . ''<span class=\\"state ''.$class.''\\">''\\r\\n      . ''<\\/span>''\\r\\n      . ''<\\/a>''\\r\\n      . ''<\\/div>'';"}' WHERE `id` = 43;
UPDATE `#__cck_core_fields` SET `title` = 'Core Type Filter (Template)', `name` = 'core_type_filter_template', `label` = 'Type', `options` = 'All Types=||Content Form=0||List=2' WHERE `id` = 47;
UPDATE `#__cck_core_fields` SET `attributes` = 'onchange="doSubmit();"' WHERE `id` = 56;
UPDATE `#__cck_core_fields` SET `options2` = '{"preparecontent":"","prepareform":"$checked1 = ( $config[''item'']->layer == ''configuration'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked2 = ( $config[''item'']->layer == ''fields'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked3 = ( $config[''item'']->layer == ''template'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$selected1 = ( $config[''item'']->layer == ''configuration'' ) ? ''selected'' : '''';\\r\\n$selected2 = ( $config[''item'']->layer == ''fields'' ) ? ''selected'' : '''';\\r\\n$selected3 = ( $config[''item'']->layer == ''template'' ) ? ''selected'' : '''';\\r\\n\\r\\n$form = ''<fieldset id=\\"layer\\" class=\\"toggle\\">''\\r\\n      . ''<input type=\\"radio\\" id=\\"layer1\\" name=\\"layer\\" value=\\"configuration\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked1.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"layer2\\" name=\\"layer\\" value=\\"fields\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked2.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"layer3\\" name=\\"layer\\" value=\\"template\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked3.'' \\/>''\\r\\n      . ''<label id=\\"layer1_label\\" for=\\"layer1\\" class=\\"toggle first ''.$selected1.''\\">''\\r\\n      . JText::_( ''COM_CCK_CONFIG'' ).''<\\/label>''\\r\\n      . ''<label id=\\"layer2_label\\" for=\\"layer2\\" class=\\"toggle ''.$selected2.''\\">''\\r\\n      . JText::_( ''COM_CCK_FIELDS'' ).''<\\/label>''\\r\\n      . ''<label id=\\"layer3_label\\" for=\\"layer3\\" class=\\"toggle last ''.$selected3.''\\">''\\r\\n      . JText::_( ''COM_CCK_TEMPLATE'' ).''<\\/label>''\\r\\n      . ''<div align=\\"center\\" class=\\"subtabs\\">''\\r\\n      . ''<div id=\\"subtab4\\"><\\/div>''\\r\\n      . ''<div id=\\"subtab5\\">''.JText::_( ''COM_CCK_OPTIONS'' ).''<\\/div>''\\r\\n      . ''<div id=\\"subtab6\\"><\\/div>''\\r\\n      . ''<\\/div>''\\r\\n      . ''<\\/fieldset>'';"}', `script` = '$j("#layer label").click(function(){\r\n $j("#layer label").removeClass(''selected''); $j(this).addClass(''selected'');\r\n var current = $j("#"+$j(this).attr(''for''));\r\n if (current.prop("checked") != true) {\r\n  $j("#layer input").removeAttr("checked"); current.attr("checked", "checked"); $j(".layers").slideUp(); if(current.val()=="configuration" && ($j("#client1").prop("checked") == true || $j("#client2").prop("checked") == true)){$j("#acl").slideDown();} else {$j("#acl").slideUp();} $j("#layer_"+current.val()).slideDown();\r\n }\r\n});' WHERE `id` = 57;
UPDATE `#__cck_core_fields` SET `options2` = '{"preparecontent":"","prepareform":"$checked1 = ( $config[''item'']->client == ''admin'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked2 = ( $config[''item'']->client == ''site'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked3 = ( $config[''item'']->client == ''intro'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked4 = ( $config[''item'']->client == ''content'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$selected1 = ( $config[''item'']->client == ''admin'' ) ? ''selected'' : '''';\\r\\n$selected2 = ( $config[''item'']->client == ''site'' ) ? ''selected'' : '''';\\r\\n$selected3 = ( $config[''item'']->client == ''intro'' ) ? ''selected'' : '''';\\r\\n$selected4 = ( $config[''item'']->client == ''content'' ) ? ''selected'' : '''';\\r\\n\\r\\n$form = ''<fieldset id=\\"client\\" class=\\"toggle\\">''\\r\\n      . ''<input type=\\"radio\\" id=\\"client1\\" name=\\"client\\" value=\\"admin\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked1.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client2\\" name=\\"client\\" value=\\"site\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked2.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client3\\" name=\\"client\\" value=\\"intro\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked3.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client4\\" name=\\"client\\" value=\\"content\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked4.'' \\/>''\\r\\n      . ''<label for=\\"client1\\" class=\\"toggle first ''.$selected1.''\\">''\\r\\n      . JText::_( ''COM_CCK_ADMIN_FORM'' ).''<\\/label>''\\r\\n      . ''<label for=\\"client2\\" class=\\"toggle ''.$selected2.''\\">''\\r\\n      . JText::_( ''COM_CCK_SITE_FORM'' ).''<\\/label>''\\r\\n      . ''<label for=\\"client3\\" class=\\"toggle ''.$selected3.''\\">''\\r\\n      . JText::_( ''COM_CCK_INTRO'' ).''<\\/label>''\\r\\n      . ''<label for=\\"client4\\" class=\\"toggle last ''.$selected4.''\\">''\\r\\n      . JText::_( ''COM_CCK_CONTENT'' ).''<\\/label>''\\r\\n      . ''<div align=\\"center\\" class=\\"subtabs\\">''\\r\\n      . ''<div id=\\"subtab1\\"><\\/div>''\\r\\n      . ''<div id=\\"subtab2\\">''.JText::_( ''COM_CCK_VIEWS'' ).''<\\/div>''\\r\\n      . ''<div id=\\"subtab3\\"><\\/div>''\\r\\n      . ''<\\/div>''\\r\\n      . ''<\\/fieldset>'';"}' WHERE `id` = 67;
UPDATE `#__cck_core_fields` SET `options2` = '{"preparecontent":"","prepareform":"$checked1 = ( $config[''item'']->client == ''search'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked2 = ( $config[''item'']->client == ''filter'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked3 = ( $config[''item'']->client == ''order'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked4 = ( $config[''item'']->client == ''list'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$checked5 = ( $config[''item'']->client == ''item'' ) ? ''checked=\\"checked\\"'' : '''';\\r\\n$selected1 = ( $config[''item'']->client == ''search'' ) ? ''selected'' : '''';\\r\\n$selected2 = ( $config[''item'']->client == ''filter'' ) ? ''selected'' : '''';\\r\\n$selected3 = ( $config[''item'']->client == ''order'' ) ? ''selected'' : '''';\\r\\n$selected4 = ( $config[''item'']->client == ''list'' ) ? ''selected'' : '''';\\r\\n$selected5 = ( $config[''item'']->client == ''item'' ) ? ''selected'' : '''';\\r\\n\\r\\n$form = ''<fieldset id=\\"client\\" class=\\"toggle\\">''\\r\\n      . ''<input type=\\"radio\\" id=\\"client1\\" name=\\"client\\" value=\\"search\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked1.'' \\/>''\\r\\n      \\/\\/. ''<input type=\\"radio\\" id=\\"client2\\" name=\\"client\\" value=\\"filter\\" ''\\r\\n      \\/\\/. ''style=\\"display: none\\" ''.$checked2.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client3\\" name=\\"client\\" value=\\"order\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked3.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client4\\" name=\\"client\\" value=\\"list\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked4.'' \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"client5\\" name=\\"client\\" value=\\"item\\" ''\\r\\n      . ''style=\\"display: none\\" ''.$checked5.'' \\/>''\\r\\n      . ''<label id=\\"client1_label\\" for=\\"client1\\" class=\\"toggle first ''.$selected1.''\\">''\\r\\n      . JText::_( ''COM_CCK_SEARCH_FORM'' ).''<\\/label>''\\r\\n      \\/\\/. ''<label id=\\"client2_label\\" for=\\"client2\\" class=\\"toggle ''.$selected2.''\\">''\\r\\n      \\/\\/. JText::_( ''COM_CCK_FILTER_FORM'' ).''<\\/label>''\\r\\n      . ''<label id=\\"client3_label\\" for=\\"client3\\" class=\\"toggle ''.$selected3.''\\">''\\r\\n      . JText::_( ''COM_CCK_ORDER'' ).''<\\/label>''\\r\\n      . ''<label id=\\"client4_label\\" for=\\"client4\\" class=\\"toggle ''.$selected4.''\\">''\\r\\n      . JText::_( ''COM_CCK_LIST'' ).''<\\/label>''\\r\\n      . ''<label id=\\"client5_label\\" for=\\"client5\\" class=\\"toggle last ''.$selected5.''\\">''\\r\\n      . JText::_( ''COM_CCK_ITEM'' ).''<\\/label>''\\r\\n      . ''<div align=\\"center\\" class=\\"subtabs\\">''\\r\\n      . ''<div id=\\"subtab1\\"><\\/div>''\\r\\n      . ''<div id=\\"subtab2\\">''.JText::_( ''COM_CCK_VIEWS'' ).''<\\/div>''\\r\\n      . ''<div id=\\"subtab3\\"><\\/div>''\\r\\n      . ''<\\/div>''\\r\\n      . ''<\\/fieldset>'';"}' WHERE `id` = 68;
UPDATE `#__cck_core_fields` SET `options2` = '{"preparecontent":"","prepareform":"if ( $value == ''0'' ) {\\r\\n $c0 = ''checked=\\"checked\\"''; $c1 = ''''; $class = ''unlinked'';\\r\\n} else {\\r\\n $c0 = ''''; $c1 = ''checked=\\"checked\\"''; $class = ''linked'';\\r\\n}\\r\\n$desc = JText::_( ''COM_CCK_STORAGE_DESC_SHORT'' );\\r\\n$form = ''<input type=\\"radio\\" id=\\"''.$name.''0\\" name=\\"''.$name.''\\" value=\\"0\\" ''.$c0\\r\\n      . '' style=\\"display:none;\\" \\/>''\\r\\n      . ''<input type=\\"radio\\" id=\\"''.$name.''1\\" name=\\"''.$name.''\\" value=\\"1\\" ''.$c1\\r\\n      . '' style=\\"display:none;\\" \\/>''\\r\\n      . ''<a href=\\"javascript: void(0);\\" id=\\"''.$name.''\\" class=\\"switch qtip_cck\\" title=\\"''\\r\\n      . $desc.''\\">''\\r\\n      . ''<span class=\\"''.$name.'' ''.$class.''\\">''\\r\\n      . ''<\\/span>''\\r\\n      . ''<\\/a>'';"}' WHERE `id` = 106;
UPDATE `#__cck_core_fields` SET `type` = "select_dynamic", `options2` = '{"query":"SELECT us.username AS text, us.id AS value FROM #__users us, #__user_usergroup_map gr WHERE gr.group_id = 8 AND gr.user_id = us.id","table":"#__content","name":"","where":"","value":"","orderby":"","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}', `rows` = '6', `divider` = ',', `bool2` = '1', `bool3` = '1' WHERE `id` = 125;
UPDATE `#__cck_core_fields` SET `rows` = '6' WHERE `id` = 134;
UPDATE `#__cck_core_fields` SET `options2` = '{"query":"","table":"#__languages","name":"title","where":"","value":"lang_code","orderby":"title","language_detection":"joomla","language_codes":"EN,GB,US,FR","language_default":"EN"}' WHERE `id` = 215;

-- --------------------------------------------------------

UPDATE `#__extensions` SET `enabled` = '1' WHERE `folder` = 'cck_field' AND ( `element` = 'freetext' || `element` = 'jform_menuitem' );
UPDATE `#__extensions` SET `enabled` = '1' WHERE `folder` = 'cck_field_link' AND ( `element` = 'content' || `element` = 'cck_list' );
UPDATE `#__modules` SET `title` = 'Search' WHERE `title` = "mod_cck_search";